import { Application } from '../Application';
import { IConfiguration } from '../../IConfiguration';
import { IMiddleware } from '../middlewares/index';
import { Token } from '@ts-ioc/core';
import { IRoute } from './IRoute';
import { RouteBuilder } from './RouteBuilder';
export interface IRouter extends IMiddleware {
    routes(map: IRoute): any;
    register(...controllers: Token<any>[]): any;
    getRoot(): IRoute;
}
export declare class Router implements IRouter, IMiddleware {
    private builder;
    private app;
    private config;
    private root;
    constructor(builder: RouteBuilder, app: Application, config: IConfiguration);
    routes(map: IRoute): void;
    register(...controllers: Token<any>[]): void;
    setup(): void;
    getRoot(): IRoute;
    static classAnnations: any;
}
